// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_architecture/src/domain/usecases/usecase.dart';
import 'package:wyatt_architecture/src/core/exceptions/exceptions.dart';
import 'package:wyatt_authentication_bloc/wyatt_authentication_bloc.dart';
import 'package:wyatt_type_utils/src/either/either_base.dart';
import 'package:wyatt_form_bloc/src/domain/form/wyatt_form.dart';

class CustomSignInCubit extends SignInCubit<int> {
  CustomSignInCubit({
    required super.authenticationRepository,
  });

  @override
  FutureOrResult<int?> onSignInWithEmailAndPassword(Result<Account, AppException> result, WyattForm form) {
    print('onSignInWithEmailAndPassword');

    return const Ok(1);
  }

  @override
  FutureOrResult<int?> onSignInAnonymously(Result<Account, AppException> result, WyattForm form) {
    print('onSignInAnonymously');

    return const Ok(1);
  }

  @override
  FutureOrResult<int?> onSignInWithGoogle(Result<Account, AppException> result, WyattForm form) {
    print('onSignInWithGoogle');

    return const Ok(1);
  }
}
