// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:equatable/equatable.dart';
import 'package:wyatt_authentication_bloc/src/domain/entities/account.dart';

/// The [Session] object is used to transport and propagate
/// the connected user [Account] and personalized [Data] in the application.
class Session<Data> extends Equatable {
  const Session({
    required this.account,
    this.data,
  });
  
  final Account account;
  final Data? data;
  
  @override
  List<Object?> get props => [account, data];

  @override
  bool? get stringify => true;
}
