// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'authentication_cubit.dart';

class AuthenticationState<Data> extends Equatable {
  const AuthenticationState._(this.status, this.wrapper);

  const AuthenticationState.unauthenticated()
      : this._(AuthenticationStatus.unauthenticated, null);

  const AuthenticationState.authenticated(SessionWrapper<Data> sessionWrapper)
      : this._(
          AuthenticationStatus.authenticated,
          sessionWrapper,
        );

  const AuthenticationState.unknown()
      : this._(AuthenticationStatus.unknown, null);

  final AuthenticationStatus status;
  final SessionWrapper<Data>? wrapper;

  @override
  List<Object?> get props => [status, wrapper];

  @override
  bool? get stringify => true;
}
